package org.springblade.enterprise.feign;

import io.swagger.annotations.ApiParam;
import org.springblade.enterprise.entity.Staff;
import org.springblade.enterprise.vo.StaffVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import javax.validation.Valid;
import java.util.List;

/**
 *  Feign
 *
 * @author lianghanqiang
 * @since 2021-03-30
 */
@FeignClient(value = "cyzh-enterprise",path = "/feign/staff")
public interface IStaffClient {

	@GetMapping("/getById")
	Staff getById(@RequestParam Long id);
	/**
	 * 详情
	 */
	@GetMapping("/detail")
    StaffVO detail(@SpringQueryMap Staff staff);

	/**
	 * 查询
	 */
	@GetMapping("/list")
    List<StaffVO> list(@SpringQueryMap Staff staff);



	/**
	 * 新增
	 */
	@PostMapping("/save")
	boolean save(@Valid @RequestBody Staff staff);

	/**
	 * 修改
	 */
	@PostMapping("/update")
    boolean update(@Valid @RequestBody Staff staff);

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
    boolean submit(@Valid @RequestBody Staff staff);


	/**
	 * 删除
	 */
	@PostMapping("/remove")
    boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids);

	/**
	 * 数量
	 */
	@GetMapping("/count")
	Integer count(@RequestParam(value = "tenantId", required = false) String tenantId);


	/***
	 * 员工数量
	 * @param staff
	 * @return
	 */
	@GetMapping("/staffCount")
	Integer staffCount(@SpringQueryMap Staff staff);

	/***
	 * 【web端 人脸权限】获取常驻人员人脸权限已下发的数量
	 * @param ids
	 * @return
	 */
	@PostMapping("/yxfCount")
	Integer yxfCount(@RequestBody List<Long> ids);


}
